import { Plus, RefreshCcw } from "lucide-react";
import type { GetServerSideProps } from "next";
import Head from "next/head";
import { useState } from "react";
import toast from "react-hot-toast";
import { AreaRiservataLayout } from "~/components/Layout";
import { LoadingPage } from "~/components/loading";
import { Status500 } from "~/components/status-page";
import { BanlistTable } from "~/components/tables/banlist-table";
import { Button } from "~/components/ui/button";
import {
	Dialog,
	DialogContent,
	DialogDescription,
	DialogHeader,
	DialogTitle,
	DialogTrigger,
} from "~/components/ui/dialog";
import { FormBanlist } from "~/forms/FormBanlist";
import type { NextPageWithLayout } from "~/pages/_app";
import type { Banlist } from "~/schemas/public/Banlist";
import { TrpcAuthedFetchingIstance } from "~/server/utils/ssgHelper";
import { api } from "~/utils/api";

/**
 * Pagina di gestione blacklist per admin: /area-riservata/admin/blacklist
 */
const AdminBlacklist: NextPageWithLayout = () => {
	const { data, isLoading, refetch } = api.banlist.getBanlist.useQuery();
	const [openEdit, setOpenEdit] = useState(false);
	const [editData, setEditData] = useState<Banlist | null>(null);

	const handleOpen = (status: boolean) => {
		setOpenEdit(status);
	};
	const handleEdit = (data: Banlist | null) => {
		setEditData(data);
	};

	if (isLoading) return <LoadingPage />;
	if (!data) return <Status500 />;

	return (
		<>
			<Head>
				<title>Utenti - Infoalloggi.it</title>
			</Head>
			<div className="mx-1 flex-1 overflow-auto">
				<div className="mx-auto pt-4">
					<div className="mx-auto items-start justify-between px-2 md:flex">
						<div className="flex items-center gap-3">
							<h3 className="font-bold text-accent-foreground text-xl sm:text-2xl">
								Black list
							</h3>
							<button
								className="cursor-pointer"
								onClick={async () => await refetch()}
								type="button"
							>
								<RefreshCcw className="size-6" />
							</button>
						</div>

						<div className="mt-3 md:mt-0">
							<EditModal
								initial={editData}
								open={openEdit}
								setOpen={handleOpen}
							/>
						</div>
						<div className="mt-3 md:mt-0">
							<Button
								className="font-semibold"
								onClick={() => {
									handleEdit(null);
									handleOpen(true);
								}}
								variant="outline"
							>
								<Plus className="size-6" />
								Nuovo
							</Button>
						</div>
					</div>

					<BanlistTable
						data={data}
						setEditData={handleEdit}
						setOpenEdit={handleOpen}
					/>
				</div>
			</div>
		</>
	);
};
export default AdminBlacklist;

export const getServerSideProps = (async (context) => {
	const access_token = context.req.cookies.access_token;

	const helpers = await TrpcAuthedFetchingIstance({ access_token });
	if (helpers) {
		await helpers.trpc.banlist.getBanlist.prefetch();
		return {
			props: {
				trpcState: helpers.trpc.dehydrate(),
			},
		};
	}
	return {
		props: {},
	};
}) satisfies GetServerSideProps;

AdminBlacklist.getLayout = function getLayout(page) {
	return <AreaRiservataLayout>{page}</AreaRiservataLayout>;
};

const EditModal = ({
	initial,
	open,
	setOpen,
}: {
	initial: Banlist | null;
	open: boolean;
	setOpen: (status: boolean) => void;
}) => {
	const utils = api.useUtils();
	const { mutate: edit } = api.banlist.updateBan.useMutation({
		onError: (error) => {
			toast.error(error.message);
		},
		onSuccess: async () => {
			toast.success("Successo");
			await utils.banlist.getBanlist.invalidate();
			setOpen(false);
		},
	});
	const { mutate: add } = api.banlist.addBan.useMutation({
		onError: (error) => {
			toast.error(error.message);
		},
		onSuccess: async () => {
			toast.success("Successo");
			await utils.banlist.getBanlist.invalidate();
			setOpen(false);
		},
	});
	const { mutate: del } = api.banlist.removeBan.useMutation({
		onError: (error) => {
			toast.error(error.message);
		},
		onSuccess: async () => {
			toast.success("Successo");
			await utils.banlist.getBanlist.invalidate();
			setOpen(false);
		},
	});

	return (
		<Dialog onOpenChange={setOpen} open={open}>
			<DialogTrigger asChild />
			<DialogContent className="sm:max-w-106.25">
				<DialogHeader>
					<DialogTitle>
						{!initial ? "Aggiungi Ban" : "Modifica Valori"}
					</DialogTitle>
					<DialogDescription className="sr-only">Edit</DialogDescription>
				</DialogHeader>
				{!initial ? (
					<div className="py-4">
						<FormBanlist
							initialValues={null}
							submitMutation={(fields) => {
								add({
									...fields,
								});
							}}
						/>
					</div>
				) : (
					<div className="py-4">
						<FormBanlist
							del={(v) => del({ id: v })}
							initialValues={{
								...initial,
							}}
							submitMutation={(fields) => {
								edit({
									...fields,
								});
							}}
						/>
					</div>
				)}
			</DialogContent>
		</Dialog>
	);
};
